<?php
/**
* ===================================================
* @author
* Name: Kishore
* Email: kishore@kishoreweblabs.com
* Url: http://www.kishoreweblabs.com
* ===================================================
* @copyright Copyright (C) 2015 kishoreweblabs (http://www.kishoreweblabs.com). All rights reserved.
@license see http://www.gnu.org/licenses/gpl-3.0.html GNU/LGPL Version 3.
* You can use, redistribute this file and/or modify it under the terms of the GNU Lesser General Public License version 3
*The user are free to edit and change  the content of file.
I hereby declare no warranty or loss to anybody using this code.
*/

defined( 'SOBIPRO' ) || exit( 'Restricted access' );

SPLoader::loadClass( 'paypal.init', false, 'application' );
 

class SPPPaypaladv extends SPPPaypal{
  
  
    public function __construct()
    {
			//	SPLang::load( 'SpApp.paypaladv' );
	}
  public function provide( $action )
	{
		return
				$action == 'PaymentMethodView' ||
				$action == 'AppPaymentMessageSend';
	}
	
	
	  
 public function AppPaymentMessageSend( &$methods, $entry, &$payment, $html = false )
    {  
	$amount=preg_replace( '/[^0-9\.,]/', null, $payment['summary']['sum_brutto'] );

if($amount<=0){
return ;
}
	
	   $order_id= $this->getOrderId( $methods, $entry, $payment );
	    
	   
	$url= JURI::ROOT();
	$url=trim($url,'/');
	$payment_url=$url.'/index.php?option=com_sobipro&sid='.$entry->get( 'id' ).'&task=paypaladv.redirect&order_id='.$order_id;
	   
	   $output = "\n";
        $output .=$this->paypal_setting['paypal_header_text'];
       
        $output .= '<a href="'.$payment_url.'">'.$payment_url.'</a>';
        	
       $output= SPLang::clean($output);
		
		 $methods[ $this->id ] = array(
            'content' => ( $output ),
            'title' => Sobi::Txt( 'PAYPALADV_PAY_WITH_PAYPAL' )
        );
	   
	   
    }	
	
	
function isNew($sid){
$res= SPFactory::db()->select( 'updatedTime,createdTime', 'spdb_object', array( 'id' => $sid ) )->loadObject();
$return =true;
if (  $res->updatedTime != $res->createdTime ) {
			 $return = false;
		}
		
		return $return;

}
	
function loadPaypalSetting(){
	SPLang::load( 'SpApp.paypaladv' );
		$db=JFactory::getDBO();	
		$pdata = SPFactory::registry()
				->loadDBSection( 'paypaladv_' . Sobi::Section() )
				->get( 'paypaladv_' . Sobi::Section() );
			
				$data= array();
				foreach($pdata as $k=>$v){
				 $data[$k]=$pdata[$k]['value'];
				}
				
				
				
					
			$query="Select * from #__sobipro_paypaladv_setting where lang_type ='lang'";
			$db->setQuery($query);
			$rows=$db->loadAssocList();
			
			foreach($rows  as $row){
					$data[$row['name']]=SPLang::getValue( $row['name'], 'application', Sobi::Section() );
					
				}
			 
			 
			 
			  $this->_debug=$data['paypal_sandbox'];
			
			
			$user = JFactory::getUser();
			if($data['joomla_login_details']==1 ){
			
			if($user->id>0){
			$data['user_field_name']=$user->name;
			$data['user_field_email']=$user->email;
			$data['user_field_id']=$user->id;
			
			}else{ // redirect to login 
			  $joomlaLoginUrl = 'index.php?option=com_users&view=login&return=';
			 $redirectUrl=base64_encode(JURI::getInstance()->toString());
              $finalUrl = $joomlaLoginUrl . $redirectUrl;
			  
			   JFactory::getApplication()->redirect( $finalUrl );
			   exit;
			}
			
			
			}else{
			
			$row=SPFactory::db()->select( 'baseData', 'spdb_field_data', array( 'sid' => $this->sid ,'fid'=>$data['user_field_name'],'lang'=>JFactory::getLanguage()->getTag()) )->loadAssoc();
			
			if($row && $row['baseData']){
			$data['user_field_name']=$row['baseData'];
			}
			
			
			$row=SPFactory::db()->select( 'baseData', 'spdb_field_data', array( 'sid' => $this->sid ,'fid'=>$data['user_field_email'],'lang'=>JFactory::getLanguage()->getTag()) )->loadAssoc();
			if($row && $row['baseData']){
			 $data['user_field_email']=$row['baseData'];
			}
			
				$data['user_field_id']=0;
			}
			
			 $this->paypal_setting=$data;
			
						
			
			 
	}	
	
function getOrderId($methods, $entry, $payment){



//$order_id=0;
$db=JFactory::getDBO();
$user = JFactory::getUser();
$amount=preg_replace( '/[^0-9\.,]/', null, $payment['summary']['sum_brutto'] );
if(isset($payment['summary']['sum_vat'])){
$vat=preg_replace( '/[^0-9\.,]/', null,$payment['summary']['sum_vat']);}
else{
$vat=0;
}
$amount=str_replace(',','.',$amount);
$vat=str_replace(',','.',$vat);

$sid=$entry->get( 'id' );
	$this->sid=$sid;

	
	$this->loadPaypalSetting();
	 

	
	
	if (  $this->isNew($sid )) {
			 $order_type = 'New';
		}else{  
				
				if(JRequest::getVar('task')=='renew'){
				$order_type='Renew';
				}else{				
				$order_type = 'Update';
				
				}
		}


	
	

$session = JFactory::getSession();
						
$order_id=$session->get('sobi_order_id_'.$sid,0);	
					
				


if($order_id){


	
$order= SPFactory::db()->select( '*', 'spdb_paypaladv_orders', array( 'id' => $order_id ) )->loadAssoc();	
		//	$this->order=$order;

							if( $payment['refNum'] && $payment['refNum']==$order['refNum']){
							
							$session->set('sobi_order_saved_'.$sid,2);
							return $order_id;
							}


						if( $payment['refNum'] && empty($order['refNum']) && $session->get('sobi_order_saved_'.$sid)==1	){
						
															
											$data = array(	'id'=>$order['id'],
												'refNum'=>$payment['refNum'],
												'order_update_date'=>date( 'Y-m-d H:i:s')
											);
											$data = (object) $data;
											$db->updateObject( '#__sobipro_paypaladv_orders', $data,'id' );
											
											$session->set('sobi_order_id_'.$sid, $order['id']);
											$session->set('sobi_order_saved_'.$sid,2);	
								}elseif($payment['refNum'] ){ // update case
								$res= SPFactory::db()->select( 'id', 'spdb_paypaladv_orders', array( 'refNum' => $payment['refNum'] ) )->loadObject();
												if(!$res){
												
													$data = array('id' =>'',
																'sid'=>$sid,
																'refNum'=>$payment['refNum'],
																'order_type'=>$order_type,
																'userid'=>$this->paypal_setting['user_field_id'] ,
																'contact_name'=>$this->paypal_setting['user_field_name'],
																'email'=>$this->paypal_setting['user_field_email'],
																'order_date'=>date( 'Y-m-d H:i:s'),
																'amount'=>$amount,
																'status'=>'Pending',
																'tax'=>$vat,
																'amount_paid'=>'',
																'processor'=>'Paypal',
																'order_update_date'=>''
															);
														
														$data = (object) $data;
													$db->insertObject( '#__sobipro_paypaladv_orders', $data );
														$order_id=$db->insertid();
														
														$session->set('sobi_order_id_'.$sid, $order_id);
												$session->set('sobi_order_saved_'.$sid,1);	
														
														
														$row=array('id'=>'',
													'order_id'=>$order_id,
													'status'=>'Pending',
													'date_added'=>date( 'Y-m-d H:i:s'),
													'txn'=>'');
										$row = (object) $row;
										$db->insertObject( '#__sobipro_paypaladv_orders_history', $row );
														
													
												}
									
									}
												
													
												
								
								
								
								


}else{


												$data = array('id' =>'',
																'sid'=>$sid,
																'refNum'=>$payment['refNum'],
																'order_type'=>$order_type,
																'userid'=>$this->paypal_setting['user_field_id'] ,
																'contact_name'=>$this->paypal_setting['user_field_name'],
																'email'=>$this->paypal_setting['user_field_email'],
																'order_date'=>date( 'Y-m-d H:i:s'),
																'amount'=>$amount,
																'status'=>'Pending',
																'tax'=>$vat,
																'amount_paid'=>'',
																'processor'=>'Paypal',
																'order_update_date'=>''
															);
														
														/*if($payment['refNum']){
														
														}*/
														
														$data = (object) $data;
														$db->insertObject( '#__sobipro_paypaladv_orders', $data );
														$order_id=$db->insertid();
												
												
												$sobi=$session->get('sobi', array());
												$sobi[]=$order_id;
												$session->set('sobi',$sobi);
												
												
												
												$session->set('sobi_order_id_'.$sid, $order_id);
												$session->set('sobi_order_saved_'.$sid,1);		
												
														
													$row=array('id'=>'',
													'order_id'=>$order_id,
													'status'=>'Pending',
													'date_added'=>date( 'Y-m-d H:i:s'),
													'txn'=>'');
										$row = (object) $row;
										$db->insertObject( '#__sobipro_paypaladv_orders_history', $row );
														
												
}

	
return $order_id;
}	
	
	
  public function PaymentMethodView( &$methods, $entry, &$payment, $message = false )
    {
		
		$db=JFactory::getDBO();
		$user = JFactory::getUser();
		
		 $order_id= $this->getOrderId( $methods, $entry, $payment );
		
		$amount=preg_replace( '/[^0-9\.,]/', null, $payment['summary']['sum_brutto'] );
		if(isset($payment['summary']['sum_vat'])){
$vat=preg_replace( '/[^0-9\.,]/', null,$payment['summary']['sum_vat']);}
else{
$vat=0;
}
		
		
		$sid=$entry->get( 'id' );
		$vatsub = Sobi::Cfg( 'payments.vat_brutto', true );	
	
	
		
	
		
		$pdata = SPFactory::registry()
				->loadDBSection( 'paypaladv_' . Sobi::Section() )
				->get( 'paypaladv_' . Sobi::Section() );
				
				
				$data= array();
				foreach($pdata as $k=>$v){
				 $data[$k]=$pdata[$k]['value'];
				}
				
				
	
				
					
			$query="Select * from #__sobipro_paypaladv_setting where lang_type ='lang'";
			$db->setQuery($query);
			$rows=$db->loadAssocList();
			
			foreach($rows  as $row){
					$data[$row['name']]=SPLang::getValue( $row['name'], 'application', Sobi::Section() );
					
				}
			 
			 $this->paypal_setting=$data;
			 
			$order= SPFactory::db()->select( '*', 'spdb_paypaladv_orders', array( 'id' => $order_id ) )->loadAssoc();	
			$this->order=$order;
		
			
			if (  $order['order_type'] =='New') {
							$item_name= $data['paypal_new_title'];
							$paypal_email['subject']=$data['paypal_new_email_subject'];
							$paypal_email['content']=$data['paypal_new_email_temp'];
				
			}elseif($order['order_type'] =='Update'){  
							$item_name= $data['paypal_update_title'];
							$paypal_email['subject']=$data['paypal_update_email_subject'];
							$paypal_email['content']=$data['paypal_update_email_temp'];
						
			}elseif($order['order_type'] =='Renew'){  
							$item_name= $data['paypal_renew_title'];
							$paypal_email['subject']=$data['paypal_renew_email_subject'];
							$paypal_email['content']=$data['paypal_renew_email_temp'];
						
			}
			
			
		
			$amount= ($order['amount']-$order['tax']);
			$notify_url='{live_site}/index.php?option=com_sobipro&sid='.$sid.'&format=raw&task=paypaladv.ipn&order_id='.$order['id'];
			$paypal_keys=array('cmd'=>'_xclick','no_shipping'=>1,'no_note'=>1,'charset'=>'UTF-8');
			$paypal_keys['business']=$data['paypal_email'];
			$paypal_keys['item_name']=$item_name;
			$paypal_keys['item_number']=$order['id'];
			$paypal_keys['notify_url']=$notify_url;
			$paypal_keys['return']=$data['paypal_return'];
			$paypal_keys['cancel_return']=$data['paypal_cancel'];
			$paypal_keys['currency_code']=$data['paypay_currency'];
			$paypal_keys['tax']=$order['tax'];
			$paypal_keys['amount']=$amount;
			$def_img='components/com_sobipro/opt/plugins/paypaladv/images/en-GB/paypal.gif';
			if(file_exists('components/com_sobipro/opt/plugins/paypaladv/images/'.JFactory::getLanguage()->getTag().'/paypal.gif')){
			$def_img='components/com_sobipro/opt/plugins/paypaladv/images/'.JFactory::getLanguage()->getTag().'/paypal.gif';
			}
			
			$paypal_keys['img']='{live_site}/'.$def_img;
			
	
	$payment_url=trim(JURI::ROOT(),'/').'/index.php?option=com_sobipro&sid='.$entry->get( 'id' ).'&task=paypaladv.redirect&order_id='.$order_id;
		
			$config = JFactory::getConfig();
			
			 $this->values = array(
            'entry' => $entry,
            'amount' => $order['amount'],
			'order'=>$order,
			'live_site'=>trim(JURI::ROOT(),'/'),
			'payment'=>$payment ,
			'section_url'=>trim(JURI::ROOT(),'/').Sobi::Url( array( 'sid' => Sobi::Reg( 'current_section' ) ) ) ,
			'payment_url'=>$payment_url,
			'sitename'=>$config->get('sitename')
			
        );
	$this->parseVar($paypal_keys);

	$this->getAdditionalFields($sid,$entry,$order,$payment,$paypal_keys);
		
		
	
			
			
			$action_url='https://www.sandbox.paypal.com/cgi-bin/webscr';
			if( $data['paypal_sandbox']==0){
			$action_url=$data['paypal_url'];
			}
			
			
			$form=$this->buildForm($action_url,$paypal_keys);
		
		
		$row = array(	'id'=>$order['id'],
						'form_data'=>$form							
											);
			$row = (object) $row;
			$db->updateObject( '#__sobipro_paypaladv_orders', $row,'id' );
		 
		$this->sendEmail($entry,$order,$payment);
					
											
											
											
			$content='';							
			$content .=$this->paypal_setting['paypal_header_text'];
			$content .=$form;
			$methods[ $this->id ] = array(
            'content' => $content,
            'title' => Sobi::Txt('PAYPALADV_PAY_WITH_PAYPAL' )
        );
			
			
	} 
	
	function parseVar(&$data){
	
	foreach($data as $k=>$v){
	$data[$k]=SPLang::replacePlaceHolders($v,$this->values);
	}
	
	
	}
	
	// use this function for calling other plugins
	function getAdditionalFields($sid,$entry,$order,$payment,&$paypal_keys){
	
	//	
	
	
	
	}
	
	function sendEmail($entry,$order,$payment){
	
	
	
	
	$db = JFactory::getDbo();
	
	
		$order_email= SPFactory::db()
					->select( '*', 'spdb_paypaladv_orders_email', array( 'order_id' => $this->order['id'],'email_type'=>'Order' ) )
					->loadObject();
					
					if($order_email && $order_email->email_sent==1){
					return ;
					}
					
					$mailer = JFactory::getMailer();
					$amailer = JFactory::getMailer();
					$config = JFactory::getConfig();
				$sender = array( 
					$config->get( 'mailfrom' ),
					$config->get( 'fromname' ) 
				);
				
	$email_data=array(
		'order_id'=>$this->order['id'],
		'email_type'=>'Order',
		'date_added'=>date( 'Y-m-d H:i:s')
		
		);
				
			
				$paypal_email=array();
				$paypal_email_admin=array();
				
				if (  $this->order['order_type'] =='New') {
											
											$paypal_email['subject']=$this->paypal_setting['paypal_new_email_subject'];
											$paypal_email['content']=$this->paypal_setting['paypal_new_email_temp'];
											$paypal_email_admin['subject']=$this->paypal_setting['paypal_new_email_subject_admin'];
											$paypal_email_admin['content']=$this->paypal_setting['paypal_new_email_temp_admin'];
							}elseif($this->order['order_type'] =='Update'){  
											
											$paypal_email['subject']=$this->paypal_setting['paypal_update_email_subject'];
											$paypal_email['content']=$this->paypal_setting['paypal_update_email_temp'];
											$paypal_email_admin['subject']=$this->paypal_setting['paypal_update_email_subject_admin'];
											$paypal_email_admin['content']=$this->paypal_setting['paypal_update_email_temp_admin'];
						
							}elseif($this->order['order_type'] =='Renew'){  
											
											$paypal_email['subject']=$this->paypal_setting['paypal_renew_email_subject'];
											$paypal_email['content']=$this->paypal_setting['paypal_renew_email_temp'];
											$paypal_email_admin['subject']=$this->paypal_setting['paypal_renew_email_subject_admin'];
											$paypal_email_admin['content']=$this->paypal_setting['paypal_renew_email_temp_admin'];
						
							}



			if($this->paypal_setting['from_email']){
		$sender[0]=trim($this->paypal_setting['from_email']);
		}
		
		if($this->paypal_setting['from_name']){
		$sender[1]=trim($this->paypal_setting['from_name']);
		}
		
			
			
								if($this->paypal_setting['paypal_enable_email']==1){
														
									$paypal_email['type']='user';
									
								
									$this->parseVar($paypal_email);
							
						/***Parsing order fields ********/
										$email=$paypal_email['content'];
										$start_tag='{start}';
										$end_tag='{end}';
										$startpos = strpos($email, $start_tag) + strlen($start_tag);
										if ($startpos !== false) {
											$endpos = strpos($email, $end_tag, $startpos);
											if ($endpos !== false) {
												$template= substr($email, $startpos, $endpos - $startpos);
											}
										}
								 		
										 $find= $template;
										 $replace='';
										  
												foreach($payment['positions'] as $key=>$val){
														if(!isset($val['netto'])){
														$val['netto']='';
														}
														if(!isset($val['vat'])){
														$val['vat']='';
														}
														if(!isset($val['brutto'])){
														$val['brutto']='';
														}
														if(!isset($val['amount'])){
														$val['amount']='';
														}
													$replace =str_replace('{payment.refnum}',$val['reference'],$template);
													$replace =str_replace('{payment.net}',$val['netto'],$replace);
													$replace =str_replace('{payment.vat}',$val['vat'],$replace);
													$replace =str_replace('{payment.gross}',$val['brutto'],$replace);
													$replace =str_replace('{payment.amount}',$val['amount'],$replace);
												}
										
										
												
						
						 $paypal_email['content']=str_replace(array($template,'{style}','{/style}',$start_tag,$end_tag),array($replace,'<style>','</style>'),$paypal_email['content']);
						 $paypal_email['subject'];
						$this->callPlugin('BeforePaypalOrderEmail',$paypal_email);
						
						$recipient = $this->order['email'];
						$mailer->addRecipient($recipient);
						$mailer->setSubject($paypal_email['subject']);
						$mailer->setBody($paypal_email['content']);
						$mailer->isHTML(true);
						$send = $mailer->Send();
						if ( $send !== true ) {
								$paypal_email['email_sent']=0;
						   //  'Error sending email: ' . $send->__toString();
						} else {
						$paypal_email['email_sent']=1;
						   
						}
						
								$email_data['email_subject']=$paypal_email['subject'];
								$email_data['email_content']=$paypal_email['content'];
							}
							
							
							
							
							if($this->paypal_setting['paypal_enable_email_admin']==1){
							
														
									$paypal_email_admin['type']='admin';
									
									$this->parseVar($paypal_email_admin);
						
						/***Parsing order fields ********/
										$email=$paypal_email_admin['content'];
										$start_tag='{start}';
										$end_tag='{end}';
										$startpos = strpos($email, $start_tag) + strlen($start_tag);
										if ($startpos !== false) {
											$endpos = strpos($email, $end_tag, $startpos);
											if ($endpos !== false) {
												$template= substr($email, $startpos, $endpos - $startpos);
											}
										}
										
										 $find= $template;
										 $replace='';
										foreach($payment['positions'] as $key=>$val){
										
										if(!isset($val['netto'])){
														$val['netto']='';
														}
														if(!isset($val['vat'])){
														$val['vat']='';
														}
														if(!isset($val['brutto'])){
														$val['brutto']='';
														}
														if(!isset($val['amount'])){
														$val['amount']='';
														}
													$replace =str_replace('{payment.refnum}',$val['reference'],$template);
													$replace =str_replace('{payment.net}',$val['netto'],$replace);
													$replace =str_replace('{payment.vat}',$val['vat'],$replace);
													$replace =str_replace('{payment.gross}',$val['brutto'],$replace);
													$replace =str_replace('{payment.amount}',$val['amount'],$replace);
										}
						
						 $paypal_email_admin['content']=str_replace(array($template,'{style}','{/style}',$start_tag,$end_tag),array($replace,'<style>','</style>'),$paypal_email_admin['content']);
						$paypal_email_admin['subject'];
						$this->callPlugin('BeforePaypalOrderEmail',$paypal_email_admin);
						
						
						$recipient=explode(',',$this->paypal_setting['paypal_email_admin']);
						//var_dump($recipient);
						$amailer->addRecipient($recipient);
						$amailer->setSubject($paypal_email_admin['subject']);
						$amailer->setBody($paypal_email_admin['content']);
						$amailer->isHTML(true);
						$send = $amailer->Send();
						if ( $send !== true ) {
								$paypal_email_admin['email_sent']=0;
						   //  'Error sending email: ' . $send->__toString();
						} else {
						$paypal_email_admin['email_sent']=1;
						   
						}
						
								$email_data['admin_email_subject']=$paypal_email_admin['subject'];
								$email_data['admin_email_content']=$paypal_email_admin['content'];
							
							}
							
								
					$email_data['email_sent']=0;
					if( (isset($paypal_email_admin['email_sent']) && $paypal_email_admin['email_sent']) || (isset($paypal_email['email_sent']) && $paypal_email['email_sent'])){
						$email_data['email_sent']=1;
						}
							$email_data = (object) $email_data;				
							
							
							if($order_email && $order_email->id){
						$email_data->id=$order_email->id;
						$db->updateObject( '#__sobipro_paypaladv_orders_email', $email_data,'id' );
						}else{
						$db->insertObject( '#__sobipro_paypaladv_orders_email', $email_data );
							}
	
	
	
	
	}
	
	function callPlugin($func,&$data){
	
	//BeforePaypalConfirmEmail
	//BeforePaypalOrderEmail
	
	}
  
  function buildForm($action_url,$paypal_keys){
  $txt='<form method="post" action="'.$action_url.'" class="paypaladv-form" id="paypaladv-form">';
  
  $this->parseVar($paypal_keys);
  foreach($paypal_keys as $k=>$v){
  if($k=='img'){
  $txt.='<input type="image" alt="" class="'.$k.'" name="submit" src="'.$v.'" />';
  }else{
  $txt.='<input type="hidden" class="'.$k.'" value="'.$v.'" name="'.$k.'"/>';
  }
  }
  

$txt.='</form>  ';

return $txt;
  }
  
		public static function admMenu( &$links )
	{ 
		SPLang::load( 'SpApp.paypaladv' );
		$links['PAYPALADV_MENU'] = 'paypaladv';
		 
	}
	
	
 
 }