<?php
/**
* ===================================================
* @author
* Name: Kishore
* Email: kishore@kishoreweblabs.com
* Url: http://www.kishoreweblabs.com
* ===================================================
* @copyright Copyright (C) 2015 kishoreweblabs (http://www.kishoreweblabs.com). All rights reserved.
@license see http://www.gnu.org/licenses/gpl-3.0.html GNU/LGPL Version 3.
* You can use, redistribute this file and/or modify it under the terms of the GNU Lesser General Public License version 3
*The user are free to edit and change  the content of file.
I hereby declare no warranty or loss to anybody using this code.
*/

defined( 'SOBIPRO' ) || exit( 'Restricted access' );
SPLoader::loadController( 'config', true );
 
 
class SPPaypaladvCtrl extends SPConfigAdmCtrl{

protected $_defTask = 'config';
 
	public function execute(){  
				SPLang::load( 'SpApp.paypaladv' );
			 	Sobi::Txt( 'PAYPALADV_TAB_CONFIGURATION_TITLE' );
				$this->_task = strlen( $this->_task ) ? $this->_task : $this->_defTask;
				switch ( $this->_task ) {
					case 'config':
						$this->screen();
						Sobi::ReturnPoint();
						break;
					case 'save':
						$this->save();
						break;
					default:
						Sobi::Error( 'SPPaymentBt', 'Task not found', SPC::WARNING, 404, __LINE__, __FILE__ );
						break;
				}
	}
	
	private function updatesettings(){
	$db=JFactory::getDBO();
		$query="Select * from #__sobipro_paypaladv_setting where name ='paypal_renew_title'";
			$db->setQuery($query);	
			if(!$db->loadObject()){
			$file=JPATH_ROOT.'/components/com_sobipro/opt/plugins/paypaladv/update.txt';
			
								$handle = fopen($file, "r");
					if ($handle) {
						while (($line = fgets($handle)) !== false) {
							// process the line read.
							
							
							$query=$line;
			
			$db->setQuery($query);
			$db->query();
			
			
			
			
						}
					
						fclose($handle);
					} else {
						// error opening the file.
					} 
			
			
			$query="Select * from #__sobipro_paypaladv_setting where name LIKE 'paypal_renew_%'";
$db->setQuery($query);
$rows=$db->loadObjectList();
			foreach($rows as $row){
			
			$data_setting_lang = array(
						'key' => $row->name,
						'value' => $row->val,
						'type' => 'application',
						'id' => Sobi::Section(),
						'section' => Sobi::Section()
					);
					
					try {
						SPLang::saveValues( $data_setting_lang );
						
					} catch ( SPException $x ) {
						//echo $message = SPLang::e( 'DB_REPORTS_ERR', $x->getMessage() ); exit;
						//Sobi::Error( 'SPPaymentBt', $message, SPC::WARNING, 0, __LINE__, __FILE__ );
						//$this->response( Sobi::Back(), $message, false, 'error' );
					}
			
			
			}
			
			
			}
	
	}
	private function screen()
	{  
	$db=JFactory::getDBO();
//	SPLang::load( 'SpApp.paypaladv' );
	//echo Sobi::Txt( 'PAYPALADV.EXPL' );
	
	$data = SPFactory::registry()
				->loadDBSection( 'paypaladv_' . Sobi::Section() )
				->get( 'paypaladv_' . Sobi::Section() );
		if ( !( count( $data ) )  ) {
		//$data=array();
			$query="Select * from #__sobipro_paypaladv_setting where lang_type !='plugin'";
			$db->setQuery($query);
			$rows=$db->loadAssocList();
			
			foreach($rows  as $row){
					$data[$row['name']]=$row['val'];
					
				}
		}else{
		
	$this->updatesettings();
		
		$query="Select * from #__sobipro_paypaladv_setting where lang_type ='lang'";
			$db->setQuery($query);
			$rows=$db->loadAssocList();
			
			foreach($rows  as $row){
					$data[$row['name']]=SPLang::getValue( $row['name'], 'application', Sobi::Section() );
					
				}
			
			}
				
		




	
	
	
			$nameFields = array();
			
			$fields = $this->getNameFields();
			$nameFields = array();
			if ( count( $fields ) ) {
				foreach ( $fields as $field ) {
					$nameFields[ $field->get( 'fid' ) ] = $field->get( 'name' );
				}
			}
			
			$nameFields[0]=' - - - - - - - - - - - - - - - - - - - - ';
			
			$js='var myfield = '.json_encode($nameFields).'; ';
			
			$sel_data['user_field_name']=0;
			$sel_data['user_field_email']=0;
			
			if(isset($data['user_field_name']['value'])){
			$sel_data['user_field_name']=$data['user_field_name']['value'];
			$sel_data['user_field_email']=$data['user_field_email']['value'];
			} 
			$js .='var sel_data='.json_encode($sel_data).';';
			
			SPFactory::header()->addJsCode($js );
			
				$view=$this->getView( 'paypaladv' );
				foreach($data as $k=>$v){
						if(is_array($v)){
						$view->assign( $data[$k]['value'], $k);
						}else{
							$view->assign( $data[$k], $k);}
						}
									
									
				$view->determineTemplate( 'extensions', 'paypaladv' );
				$view->display();
	
		
		
	}
	
	
	public function getNameFields( $pos = false, $types = array() )
	{
		
		$cache = array( 'pos' => null, 'npos' => null );
	
		if ( $pos ) {
			if ( $cache[ 'pos' ] ) {
				return $cache[ 'pos' ];
			}
			if ( !( count( $types ) ) ) {
				$types = explode( ', ', Sobi::Cfg( 'field_types_for_ordering', 'inbox, select' ) );
			}
		}
		else {
			if ( $cache[ 'npos' ] ) {
				return $cache[ 'npos' ];
			}
			if ( !( count( $types ) ) ) {
				$types = explode( ', ', Sobi::Cfg( 'field_types_for_name', 'inbox' ) );
			}
		}

		try {
			$fids = SPFactory::db()
					->select( 'fid', 'spdb_field', array( 'fieldType' => $types, 'section' => Sobi::Reg( 'current_section' ) ) )
					->loadResultArray();
		} catch ( SPException $x ) {
			Sobi::Error( $this->name(), SPLang::e( 'CANNOT_GET_FIELD_FOR_NAMES', $x->getMessage() ), SPC::WARNING, 0, __LINE__, __FILE__ );
		}
		$fields = array();
		if ( count( $fids ) ) {
			foreach ( $fids as $fid ) {
				$f = SPFactory::Model( 'field', true );
				$f->init( $fid );
				try {
					$f->setCustomOrdering( $fields );
				} catch ( SPException $x ) {
					$fields[ $fid ] = $f;
				}
			}
		}
		$cache[ $pos ? 'pos' : 'npos' ] = $fields;
		return $fields;
	}
	
	protected function save()
	{
		if ( !( SPFactory::mainframe()->checkToken() ) ) {
			Sobi::Error( 'Token', SPLang::e( 'UNAUTHORIZED_ACCESS_TASK', SPRequest::task() ), SPC::ERROR, 403, __LINE__, __FILE__ );
		}
		$this->validate( 'extensions.paypaladv', array( 'task' => 'paypaladv', 'pid' => Sobi::Section() ) );
		
		
	$db=JFactory::getDBO();	
		
		$data_setting=array();
		
			$query="Select name from #__sobipro_paypaladv_setting where lang_type ='nonlang'";
			$db->setQuery($query);
			$rows=$db->loadAssocList();
			
			foreach($rows  as $row){
					$data_setting[]=array('key'=>$row['name'],'value'=>JRequest::getVar($row['name'],'', 'post', 'string', JREQUEST_ALLOWHTML));
				}
		
		SPFactory::registry()->saveDBSection($data_setting, 'paypaladv_' . Sobi::Section());
		
		
			$query="Select name from #__sobipro_paypaladv_setting where lang_type ='lang'";
			$db->setQuery($query);
			$rows=$db->loadAssocList();
		
			foreach($rows  as $row){
	
		
		$data_setting_lang = array(
			'key' => $row['name'],
			'value' => JRequest::getVar($row['name'],'', 'post', 'string', JREQUEST_ALLOWHTML),
			'type' => 'application',
			'id' => Sobi::Section(),
			'section' => Sobi::Section()
		);
		
		try {
			SPLang::saveValues( $data_setting_lang );
			
		} catch ( SPException $x ) {
			echo $message = SPLang::e( 'DB_REPORTS_ERR', $x->getMessage() ); exit;
			Sobi::Error( 'SPPaymentBt', $message, SPC::WARNING, 0, __LINE__, __FILE__ );
			$this->response( Sobi::Back(), $message, false, 'error' );
		}
		
		}
		
		
		$this->response( Sobi::Back(), Sobi::Txt( 'MSG.ALL_CHANGES_SAVED' ), false, 'success' );
	}

}